/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

//  interface for the cClient class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__CLIENT_H__)
#define __CLIENT_H__

#include "typedefs.h"

class cClient  
{
protected:
	int		socket;
//	bool	dragging;
public:
	cClient(int s);
	~cClient();
	UOXSOCKET GetSocket();
	cChar* getPlayer();
	bool IsDragging();
	void SetDragging();
	void ResetDragging();
	void SysMsg(char* text);
};

class AllPlayersIterator
{
protected:
	unsigned int pos;
	virtual P_CHAR _GetData(void);
public:
	AllPlayersIterator()						{ pos = 0; }
	virtual ~AllPlayersIterator()						{ }
	P_CHAR GetData(void);
	P_CHAR First();
	P_CHAR Next();
	AllPlayersIterator& operator++(int/* inc*/)	{ pos++; return *this; }
	inline UOXSOCKET getSocket()				{ return pos; }
};

class AllPlayersInRangeIterator : public AllPlayersIterator
{
protected:
	P_CHAR Center;
	virtual P_CHAR _GetData(void);

public:
	AllPlayersInRangeIterator(P_CHAR pc1)		{ pos = 0; Center = pc1; }
	virtual ~AllPlayersInRangeIterator()						{ }
};

/////////////////////////////////////////////////
// note: this class will get more usefull later
// *after* login/logout redesign completed.
// 
// LB 27-12-2003
/////////////////////////////////////////////////

#include <string>

class cClientData
{
  public:
	  std::string clientVersion;
};

#endif

