/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined(__TIMING_H__)
#define __TIMING_H__

#include "platform.h"
#include "chars.h"

void checkauto();	// Check automatic/timer controlled stuff (Like fighting and regeneration)
void checktimers();	// Check shutdown timers


enum ePerfTimers
{
	PTM_npcwalk=0,
	PTM_npcai=1,
	PTM_fieldeffect=2,
	PTM_max=3
};

class cPerfTimers
{
protected:
	cTimer master;
	cTimer timers[PTM_max];
	void  advance();
public:
	cPerfTimers();
	void  setSecs(enum ePerfTimers tmr,int val);
	void  setMilliSecs(enum ePerfTimers tmr,int val);
	bool  hasExpired(void);
	bool  hasExpired(enum ePerfTimers tmr);
	void  advance(enum ePerfTimers tmr);
	void  reset(enum ePerfTimers tmr);
};


#endif

