/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined(__BOOKS_H__)
#define __BOOKS_H__


// Book class by Lord Binary, 7'th december 1999

// new books readonly -> morex  999
// new books writeable -> morex 666
// old books from misc.scp, readonly: neither type 666 nor 999, section# = more-value
// of course ALL books need a type of 11

// note to everyone who wants to learn C++ -> this is NOT stricly OOP and has no good OOD.
// hence no real good example for OO-P :)
// for example inheritence could be used, public attributes arnt nice etc,etc.


// Platform Specifics
#include "platform.h"
#include "defines.h"
#include "typedefs.h"
#include <fstream>
#include <string>
/*
 *	bok file format version 1 (UPDATED Dec. 6, 2003)
 *         NOTE-packets are going to UTF-8, so wont always be one character per byte i the future
 *	version [4]    Note, currently set to 1
 *  pagenum [2]    Number of pages the book has, binary number
 *  title [256]     Null terminated, so actual length is 511 max
 *  author [256]   Null terminated, so actual length is 511 max
 *  Repeat for each page
 *  line{10][256]       Note, only 34 bytes per line,we are reserviing space for more
 *        
 *
 *  bok file format (UOX version, pre Dec 6, 2003)
 * title[62]
 * author[32]
 * numpages[5]  <<<<<<<, text, not binary
 * For each page
 * cr[1]      <<<<< carriage return
 * line[34]   <<<<<< repeated 8 times ( 8 lines per page)
 * 
*/		 
class cBooks
{
	private:
		// that private methods read and write from the *.bok files
		std::string makeBookName(P_ITEM pBook) ;
		void writeTitleAuthor(std::fstream& file,std::string value, int seek) ;
		std::string readTitleAuthor(std::fstream& file,int seek) ;
		std::string title(std::fstream& file) ;
		void title(std::fstream& file, std::string value) ;
		std::string author(std::fstream& file) ;
		void author(std::fstream& file, std::string value) ;
		short pagecount(std::fstream& file) ;
		void pagecount(std::fstream& file, short pagenum) ;
		bool oldBokFormat(std::fstream& file) ;
		void convertBok(P_ITEM pBook,std::fstream& file) ;
		std::string line(std::fstream& file, int pagenum, int linenum) ;
		void line(std::fstream& file, int pagenum, int linenum, std::string value) ;
		void makeBookFile(std::string filename,short numpages) ;
		void prepareFile(P_ITEM pBook) ;
		bool useD4(UOXSOCKET s) ;


	   //signed char make_new_book_file(char *fileName, P_ITEM pBook); // "formats and creates a new bok file"
					
	public:
		cBooks();

        void openbook_scp(UOXSOCKET s, P_ITEM pBook); // opens old-readonly books, takes data from misc.scp
		
		void openbook(UOXSOCKET s, P_ITEM pBook,char writeable); // opens new books

		void readbook_readonly_scp(UOXSOCKET s, P_ITEM pBook, int p); // reads books from misc.scp, readonly = old books
		                                                        
		void readbook_readonly(UOXSOCKET s, P_ITEM pBook, int p);     // reads new books readonly ( from *.bok file )
		                                                     		                                                      
		void delete_bokfile(P_ITEM pBook); // deletes bok-file.

		void processBookPacket(UOXSOCKET s);
		void processOldBookHeaderPacket(UOXSOCKET s);
		void processBookHeaderPacket(UOXSOCKET s);

		virtual ~cBooks();

		std::string clickTitle(P_ITEM pBook, bool btype) ;
        	
};
#endif
