/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

// Global Variables

#include "network.h"
#include "sregions.h"
#include "wolfpack.h"
#include "accounts.h"
#include "Client.h"

#include "verinfo.h"
#if defined(__unix__)
termios termstate ;
#endif
unsigned int uiCurrentTime;
wp_version_info wp_version;

//	Instantiate our console object

cConsole Console;
bool Daemon ;       
#ifndef __unix__
WSADATA wsaData;
WORD wVersionRequested;

#else
      
char* strlwr(char* str)
{
	for (unsigned int i=0;i<strlen(str);i++)
		str[i]=tolower(str[i]);
	return str;
}
char* strupr(char* str)
{
	for (unsigned int i=0;i<strlen(str);i++)
		str[i]=toupper(str[i]);
	return str;
}
#endif

list<connectionAccountSt>connections;

unsigned int polyduration=90;

int gatecount=0;

timeLight_st timeLight;

int openings=0;
unsigned char numMaps=0;
int serverkey=0x01010101;

int len_connection_addr;
struct sockaddr_in connection;
struct sockaddr_in client_addr;
int err, error;
int keeprun;
unsigned int a_socket;

fd_set conn ;
fd_set all ;

unsigned int nfds;
timeval uoxtimeout;
unsigned int now;

FILE *scpfile, *lstfile, *wscfile;

repsys_st repsys;
resource_st resource;

//unsigned char w_anim[3]={0x1d,0x95,0}; // flying blood instead of lightnings, LB in a real bad mood

CArray<3, unsigned int>w_anim;

unsigned int raindroptime;

char *cline;
int tnum;

unsigned int starttime, endtime, lclock;
unsigned char overflow;
unsigned char wtype;
int executebatch;
int showlayer;

unsigned int shoprestocktime=0;
int shoprestockrate=5;

unsigned long int TotalLoopCount    = 0;
unsigned long int LastMeasureCycleLoopCount = 0;
unsigned long int TotalCpuTime = 0;
unsigned long int sleptTotal   = 0;
unsigned long int EmuStartTime = 0;
int               TotalMC=0;
unsigned long int TotalLoopCountII=0;
unsigned long int LastMeasureCycleTime;
const unsigned long int  MinMeasureCycleTime=250; // milli-secs
bool              firstcycleok=false;
bool              worldsaved=false;

int global_lis=1;

unsigned long int serverstarttime;

tracking_st tracking_data = {TRACKINGRANGE,MAXTRACKINGTARGETS,TRACKINGTIMER,TRACKINGDISPLAYTIME};
begging_st begging_data; // was = {BEGGINGRANGE,"Could thou spare a few coins?","Hey buddy can you spare some gold?","I have a family to feed, think of the children."};
fishing_st fishing_data;
spiritspeak_st spiritspeak_data;
speed_st speed;
int triggerx;
int triggery;
signed char triggerz;
char debug_network;

int escortRegions = 0;


//-=-=-=-=-=-=-Classes Definitions=-=-=-=-=-=//
cSrvParms		*SrvParms;
CWorldMain		*cwmWorldState;
cRegion			*mapRegions;
cAdmin			*Admin;
cBoat			*Boats;
cCombat			*Combat;
cCommands		*Commands;
cGuilds			*Guilds;
cGump			*Gumps;
cAllItems		*Items;
cMapStuff		*Map;
cCharStuff		*Npcs;
cSkills			*Skills;
cWeight			*Weight;
cTargets		*Targ;
cNetworkStuff	*Network;
cOldMagic		*OldMagic;
cMagic			*Magic;
cBooks          *Books;
cAccount		*Accounts;
cAllTmpEff		*AllTmpEff;
CVirtues        *Virtues;
mapDispatcher   *AllMaps;
LWCrypt         *LightweightCrypt;
tileInfo        *TileData;
multis          *Multi; 
cPartySystem	*PartySystem;
countTraffic    *Traffic;
CParticleEffects *ParticleEffects;
cSkillManagement *SkillManager;
cTitle			*Titles;
cClientVersion  *ClientVersion;

const unsigned int DUMMYSOCKET=12345;

Container_cl stablesp, imultisp, cmultisp;

ServerList_st serv; // Servers list

unsigned char particleSystem[49];

std::vector<std::string> clientsAllowed; // client version controll system
bool lastConnectionDisconned;

PacketWriter PacketSender(PSS_SMARTBUFFER);
PacketReader PacketFetcher[MAXCLIENT];


//////////////////// ARRAYS ////////////////////

CArray<MAXCLIENT, SERIAL>runebookg("runebookg");

/////////////////////////////////////////////
///             MAXCLIENT arrays          ///
/////////////////////////////////////////////
// maximum too cause maxclient = maximum +1

 CArray<MAXCLIENT, antimacro_st>AntiMacro("Antimacro");
 CArray<MAXCLIENT+1, unsigned long int>LASTRECVTIME("LASTRECEIVETME");
 CArray<MAXCLIENT+1, char>noweather("noweather"); //LB
 CArray<MAXCLIENT, unsigned char>LSD("LSD");
 CArray<MAXCLIENT, unsigned char>DRAGGED("DRAGGED");
 CArray<MAXCLIENT, unsigned char>EVILDRAGG("EVILDRAGG"); // we need this for UO3D clients to save dragging history , LB
 CArray<MAXCLIENT, bool>firstpacket("firstpacket");
 CArray<MAXCLIENT, char>FBERRCNT("FBERRCNT");

// meta gm variables
 CArray<MAXCLIENT, int>priv3a("priv3a"); // sorry, my stupidity, (Lord Binary). basically not necassairy. but no time to rewrite now.
 CArray<MAXCLIENT, int>priv3b("priv3b"); // needed until priv3target rewritten
 CArray<MAXCLIENT, int>priv3c("priv3c");
 CArray<MAXCLIENT, int>priv3d("priv3d");
 CArray<MAXCLIENT, int>priv3e("priv3e");
 CArray<MAXCLIENT, int>priv3f("priv3f");
 CArray<MAXCLIENT, int>priv3g("priv3g");
// end of meta gm variables

 CArray<MAXCLIENT, CArray<MAXBUFFER_REAL, char unsigned> >buffer("buffer");
 CArray<(MAXCLIENT)*10, int>whomenudata("whomenudata");   // LB, for improved whomenu, ( is important !!!

 CArray<MAXCLIENT, unsigned int>client("client");
 CArray<MAXCLIENT, short int>walksequence("walksequence");
 CArray<MAXCLIENT, signed char>addid5("addid5");
 CArray<MAXCLIENT, int>acctno("acctno");
 CArray<MAXCLIENT, CHARACTER>currchar_("currchar");
 CArray<MAXCLIENT,make_st>itemmake("itemmake");
 CArray<MAXCLIENT,int>tempint("tempint");
 CArray<MAXCLIENT,unsigned char>addid1("addid1");
 CArray<MAXCLIENT,unsigned char>addid2("addid2");
 CArray<MAXCLIENT,unsigned char>addid3("addid3");
 CArray<MAXCLIENT,unsigned char>addid4("addid4");
 CArray<MAXCLIENT,unsigned char>dyeall("dyeall");
 CArray<MAXCLIENT,int>addx("addx");
 CArray<MAXCLIENT,int>addy("addy");
 CArray<MAXCLIENT,int>addx2("addx2");
 CArray<MAXCLIENT,int>addy2("addy2");
 CArray<MAXCLIENT,signed char>addz("addz2");
 CArray<MAXCLIENT,int>addmitem("addmitem");
 
 CArray<MAXCLIENT,unsigned char>perm("perm");
 CArray<MAXCLIENT,unsigned char>cryptclient("cryptclient");
 CArray<MAXCLIENT,unsigned char>usedfree("usedfree");
 
 CArray<MAXCLIENT,int>clickx("clickx");
 CArray<MAXCLIENT,int>clicky("clicky");
// CArray<MAXCLIENT,int>currentSpellType("currenspelltype"); // 0=spellcast, 1=scrollcast, 2=wand cast
 CArray<MAXCLIENT,unsigned char>targetok("targetok");
 CArray<MAXCLIENT,unsigned char>clientDimension("clientdimension");

 CArray<MAXCLIENT,cClientData>clientData("clientData");
  

/////////////////////////////////////////////
///             hasmax                   ///
/////////////////////////////////////////////


// - the below structure is for looking up items based on serial #
// - item's serial, owner's serial, char's serial, and container's serial

/* defines for debugging only, to remove for official releases!
#define itemsp itemsp_.prepare(DBGFILE,__LINE__)
#define charsp charsp_.prepare(DBGFILE,__LINE__)
*/

 CArray<HASHMAX, lookuptr_st>itemsp("itemsp");
 CArray<HASHMAX, lookuptr_st>charsp("charsp");

 CArray<HASHMAX, lookuptr_st>spawnsp("spawnsp");
 CArray<HASHMAX, lookuptr_st>contsp("contsp");
 CArray<HASHMAX, lookuptr_st>cownsp("cownspsp");
 CArray<HASHMAX, lookuptr_st>cspawnsp("cspawnsp");
 CArray<HASHMAX, lookuptr_st>glowsp("glowsp");
 CArray<HASHMAX, lookuptr_st>ownsp("owns");


/******************************************************/

///////////////////////////////////////////
///   and the rest                        /
///////////////////////////////////////////


 CArray<MAXGATES, CArray<2, int> >gatex("gatex");
 CArray<MAXGATES, CArray<2, int> >gatey("gatey");
 CArray<MAXGATES, CArray<2, signed char> >gatez("gatez");

 CArray<256, region_st>region("region");

 CArray<256, CArray<7, unsigned int> >metagm("metagm"); // for meta gm script

 CArray<CMAX, unsigned char *>comm("comm");

 CArray<256, int>validEscortRegion("validEscortRegion");
 CArray<11, jail_st>jails("jails");

/////////////////////////////////////////
///////////// global string vars /////////
/////////////////////////////////////////

char tbuffer[MAXBUFFER_REAL];

char spellname[71][25]={
        "Clumsy","Create Food","Feeblemind","Heal","Magic Arrow","Night Sight","Reactive Armor","Weaken",
        "Agility","Cunning","Cure","Harm","Magic Trap","Magic Untrap","Protection","Strength",
        "Bless","Fireball","Magic Lock","Poison","Telekinesis","Teleport","Unlock","Wall Of Stone",
        "Arch Cure","Arch Protection","Curse","Fire Field","Greater Heal","Lightning","Mana Drain","Recall",
        "Blade Spirits","Dispel Field","Incognito","Magic Reflection","Mind Blast","Paralyze","Poison Field","Summon Creature",
        "Dispel","Energy Bolt","Explosion","Invisibility","Mark","Mass Curse","Paralyze Field","Reveal",
        "Chain Lightning","Energy Field","Flame Strike","Gate Travel","Mana Vampire","Mass Dispel","Meteor Swarm","Polymorph",
        "Earthquake","Energy Vortex","Resurrection","Summon Air Elemental",
        "Summon Daemon","Summon Earth Elemental","Summon Fire Elemental","Summon Water Elemental",
        "Random", "Necro1", "Necro2", "Necro3", "Necro4", "Necro5"
};

// Script files that need to be cached
// Crackerjack Jul 31/99
 char n_scripts[NUM_SCRIPTS][512] =
 {"items.scp","npc.scp","create.scp","regions.scp",
	"misc.scp", "skillsnew.scp", "location.scp","menus.scp",
	"spells_new.scp", "speech.scp","tracking.scp", "newbie.scp",
	"titles.scp", "advance.scp", "triggers.scp", "ntrigrs.scp",
	"wtrigrs.scp", "necro.scp", "house.scp", "colors.scp",
	"spawn.scp", "htmlstrm.scp", "metagm.scp", "polymorph.scp",
	"harditems.scp", "", "", "menupriv.scp", "carve.scp", 
	"msgboard.scp", "fishing.scp", "gumps.scp",  "startlocs.scp", 
	"maps.scp", "townhouse.scp", "reserve.scp", "resources.scp", "races.scp"};//the two ""s are for custom scripts.
 Script *i_scripts[NUM_SCRIPTS];

 unsigned char zeros[1024]={0,};

 char xtext[MAXCLIENT][121];

 char start[MAXSTART][5][128]; // startpoints list
 char idname[256];
 char script1[512];
 char script2[512];
 char script3[512];

 char gettokenstr[256];

 char temp[1024];
 char temp2[1024];
 char temp3[1024];
 char schei___[512];

 char scpfilename[32];//AntiChrist


// accessors for globals (Duke, 7.4.2002)
int getAddid1_4(UOXSOCKET s)
{
	return ((addid1[s] << 24)+(addid2[s] << 16)+(addid3[s] << 8)+addid4[s]);
}
void setAddid1_4(UOXSOCKET s, int ser)
{
	addid1[s]=(unsigned char) (ser >> 24);
	addid2[s]=(unsigned char) (ser >> 16);
	addid3[s]=(unsigned char) (ser >> 8);
	addid4[s]=(unsigned char) (ser);
}

/////////////////////////////////////

std::string ascii_art_1[8];
std::string ascii_art_2[8];
std::string ascii_art_3[8];
std::string ascii_art_4[8];
std::string ascii_art_5[25];
char ascii_art_rows[5];
