/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __GUMPS_H__
#define __GUMPS_H__

#include "platform.h"
#include "typedefs.h"
#include <stdio.h>
#include "cGumps.h"

class cGump
{
public:
	void Button(int s, SERIAL serial, unsigned int button,  int type);
	void Input(int s);
	void Menu(UOXSOCKET s, int m, P_ITEM Sign=NULL);
	void Open(int s, int serial, int num, int num2);
	void RuneBook(int s, int type, P_ITEM Book);
	void RuneBookButton(int s, unsigned int button,  P_ITEM Book);
};

void choice(int s);
void entrygump(int s, SERIAL serial, unsigned char type, char index, short int maxlength, char *text1);
void gmmenu(int s, int m);
void itemmenu(int s, int m);
void playermenu(int s, int type, char* filter);
void tweakmenu(UOXSOCKET, SERIAL);
void whomenu(int s, int type, char* filter, int searchbyaccount);

// LB 4-5-2k3
class CTithing
{
    public:
		CTithing::CTithing(void);
		virtual~CTithing(void);
		void showTithingGump(UOXSOCKET s);			
	    void ButtonHandler(int id, unsigned int subid, UOXSOCKET s);
		void setGoldandTithing(int gold, int tithing);
	
	private:

		CGumps<0x0300>*DaGump;		
		const int okButtonId;
		const int outerleftButtonId;
		const int leftButtonId;
		const int rightButtonId;
		const int outerrightButtonId;
};

class CAddMenu
{
   public:
		CAddMenu::CAddMenu(int imn, int imnprev);
		virtual~CAddMenu(void);
		inline void showAddGump(UOXSOCKET s) { TheGump->SendGump(s); }			
	    void ButtonHandler(int id, int subid, UOXSOCKET s);		
	
	private:

		CGumps<0x1000>*TheGump;		
			

};

#endif

