/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __MAPSTUFF_H__
#define __MAPSTUFF_H__

#include "platform.h"
#include "rectangle.h"
#include "tiledata.h"

/// somewhat bad design, needs to be replaced
/// storing most important data of tile_st, land_st, multi_st in one ...
/// nah, dont like that, in map rewrite phase 3 it will be most likely killed

// XYZZY
struct unitile_st
{
	signed char basez;
	unsigned char type; // 0=Terrain, 1=Item
	unsigned short int id;
	unsigned int flags;
	signed char height;
	unsigned char weight;
};


class cMapStuff
{	
	// Functions
private:
	signed char MultiHeight(P_ITEM iMulti, const cCoord& pos, signed char oldz);
	int MultiTile(P_ITEM iMulti, cCoord& pos, signed char oldz);
	
	int DynTile(cCoord& pos, signed char oldz );
	bool DoesTileBlock(int tilenum);
	bool DoesStaticBlock(short int x, short int y, signed char oldz);
	
public:
	cMapStuff()  { ; }  // change
	~cMapStuff() { ; } // change
	
	// height functions
	bool IsUnderRoof(short int x, short int y, signed char z);
	signed char StaticTop(const cCoord& pos, signed char oldz);
	signed char DynamicElevation(const cCoord& pos, signed char oldz);
	signed char MapElevation(const cCoord& pos);
	signed char MapElevation(short int x, short int y);
	signed char AverageMapElevation(const cCoord& pos, int &id);
	signed char TileHeight( int tilenum );
	signed char Height(cCoord& pos, signed char oldz);

	// look at tile functions
	void MultiArea(PC_ITEM iMulti, int *x1, int *y1, int *x2, int *y2);
	void MultiArea(PC_ITEM iMulti, cRectangle& rect);
	
	bool IsRoofOrFloorTile( tileData *tile );
	bool IsRoofOrFloorTile( unitile_st *tile );
	
	// misc functions
	bool CanMonsterMoveHere(cCoord& pos, signed char oldz );

	bool IsBlockedByChar(cCoord* pos);
	bool IsBlockedByItem(cCoord* pos);
	bool IsBlockedByCharOrItem(cCoord* pos);
};

// use this value whereever you need to return an illegal z value
const signed char illegal_z = -128;	// reduced from -1280 to -128, to fit in with a valid signed char

#endif
