/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined (__POINTER_H__)
#define __POINTER_H__

#include "typedefs.h"
//#include "structs.h"

struct lookuptr_st // Tauriel  used to create pointers to the items dynamically allocated
{               //         so don't mess with it unless you know what you are doing!
	int max;
	int *pointer;
};

bool BuildPointerArray();
int	ContainerCountItems(const int serial, short id=-1, short color=-1, short type=-1);
P_ITEM ContainerSearch(const int serial, int *ci);
P_ITEM ContainerSearchFor(const int serial, int *ci, short id, short color=-1);
int findbyserial(lookuptr_st *ptr, int nSerial, int nType);// - find item in a pointer array
P_CHAR FindCharBySerial(int serial);
P_CHAR FindCharBySerPtr(unsigned char *p);
P_CHAR FindWearerOf(PC_ITEM pi);
P_ITEM FindItemBySerial(int serial);
P_ITEM FindItemBySerPtr(unsigned char *p);
void removefromptr(lookuptr_st *ptr, int nItem);// - remove item from pointer array
void removefromptr(lookuptr_st *ptr, P_CHAR pc);
void removefromptr(lookuptr_st *ptr, PC_ITEM pi);
P_CHAR SearchOwnedPets(const int serial, int *ci);
P_ITEM SearchOwnedItems(const int serial, int *ci);
P_ITEM SearchSpawnedItems(const int serial, int *ci);
P_CHAR SearchSpawnedChars(const int serial, int *ci);
void setptr(lookuptr_st *ptr, int item);
void setptr(lookuptr_st *ptr, P_CHAR pc);
void setptr(lookuptr_st *ptr, PC_ITEM pi);

#endif
