/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//
#include "rcvpkg.h"

#include "Client.h"
#include "guilds.h"
#include "skills.h"
#include "SndPkg.h"

#include "wolfpack.h"

#include "debug.h"
#undef DBGFILE
#define DBGFILE "rcvpkg.cpp"

void RcvAttack(P_CLIENT ps)
{
	UOXSOCKET s=ps->GetSocket();
	P_CHAR Player = ps->getPlayer();
	if (!Player) return;

	P_CHAR pc_i = FindCharBySerPtr(&buffer[s][1]);
	if (pc_i == NULL) return;	//to avoid problems
	
	if (Player->dead)//AntiChrist stuff
	{
		if (SrvParms->persecute)
		{//start persecute stuff - AntiChrist
			Player->SetTarget(pc_i);
			Skills->Persecute(s);
		}
		else
			sysmessage(s,"You are dead and cannot do that.");
		return;
	}
	if (Player->cell>0)
	{
		sysmessage(s,"There is no fighting in the jail cells!");
		return;
	}

	if (!Player->dead)
	{
		Player->SetTarget(pc_i);
		Player->unhide();
		Player->disturbMed(s);

		
		if (pc_i->dead || pc_i->Hp()<=0)//AntiChrist
		{
			sysmessage(s,"That person is already dead!");
			return;
		}
		
		if (pc_i->isAiVendor())//PlayerVendors
		{
			sprintf(temp, "%s cannot be harmed.",pc_i->name);
			sysmessage(s, temp);
			return;
		}
		
		SndAttackOK(s, pc_i->serial);	//keep the target highlighted       
		if (pc_i->HasTarget())
		{
			pc_i->setAttacker(Player);
			pc_i->resetAttackFirst();
		}
		Player->setAttackFirst();
		Player->setAttacker(pc_i);
 
		if (pc_i->guarded)
		{
			P_CHAR toCheck;
			AllCharsIterator aci;
			for (aci.Begin(); (toCheck=aci.GetData()) != NULL; aci++)
			{
				if (pc_i->Owns(toCheck) && toCheck->npcaitype == 32 && Player->dist(toCheck) <= 10 )
				{
					npcattacktarget(Player, toCheck);
				}
			}
		}

		if (pc_i->inGuardedArea() && SrvParms->guardsactive)
		{
			if (pc_i->npc==0 && pc_i->isInnocent() && Guilds->Compare(Player, pc_i)==0) //REPSYS
			{
				criminal(Player);
				Npcs->SpawnGuard(Player, pc_i ,Player->pos);
			}
			else if ( pc_i->npc && pc_i->isInnocent() && !pc_i->isHuman() && !pc_i->isAiTeleGuard() )
			{
				criminal(Player);
				Npcs->SpawnGuard(Player, pc_i, Player->pos);
			}
			else if ( pc_i->npc && pc_i->isInnocent() && pc_i->isHuman() && !pc_i->isAiTeleGuard() )
			{
				npctalkall(pc_i, "Help! Guards! I've been attacked!", 1);
				criminal(Player);
				callguards(pc_i);
			}
			else if ( pc_i->npc && pc_i->isAiTeleGuard())
			{
				criminal(Player);
				npcattacktarget(pc_i, Player);
			}
			else if ((pc_i->npc || pc_i->tamed) && !pc_i->war && !pc_i->isAiTeleGuard())
			{
				npcToggleCombat(pc_i);
				pc_i->npcmovetime=(unsigned int)(uiCurrentTime+(double)(NPCSPEED*MY_CLOCKS_PER_SEC)); //*16));
			}
			else
			{
				pc_i->npcmovetime=(unsigned int)(uiCurrentTime+(double)(NPCSPEED*MY_CLOCKS_PER_SEC)); //*16));
			}
			
			sprintf(temp, "You see %s attacking %s!", Player->name, pc_i->name);
			
			unsigned int j;
			for (j=0;j<now;j++)
			{
				if (perm[j])
				{
					if (inrange1pl(Player, currchar(j)))
					{
						pc_i->emotecolor=0x0026;
						npcemote(j, Player, temp,1);
					}
				}
			}
		}
		else	// not a guarded area
		{
			if (pc_i->isInnocent())
			{
				if (!pc_i->npc && Guilds->Compare(Player, pc_i)==0)
				{
					criminal(Player);
				}
				else if (pc_i->npc && pc_i->tamed)
				{
					criminal(Player);
					pc_i->FightBack(Player);
				}
				else if (pc_i->npc)
				{
					criminal(Player);
					pc_i->FightBack(Player);
					if (pc_i->isHuman() )
					{
						npctalkall(pc_i, "Help! Guards! Tis a murder being commited!", 1);
					}
				}
			}
		}
	}
}
