/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __RECTANGLE_H__
#define __RECTANGLE_H__

/////////////////////
// Name:	cRectangle
// Purpose:	a rectangle for coordinates of type short
// Remark:	does not check if the coords are suitable for UO !
// History:	by Duke, 26.12.01
//
class cRectangle
{
public:
	short lowerLeftX;
	short lowerLeftY;
	short upperRightX;
	short upperRightY;
	cRectangle();
	cRectangle(short x1, short y1, short x2, short y2);
	~cRectangle() { }
	void init(short x1, short y1, short x2, short y2);
	bool includes(short x, short y) const;
	bool overlaps(cRectangle& other) const;
};

class cMapRectangle
{
private:
public:
	cRectangle rect;
	short mapNo;
	cMapRectangle();
	cMapRectangle(short x1, short y1, short x2, short y2, short map = 0);
	~cMapRectangle() { }
	void init(short x1, short y1, short x2, short y2, short map = 0);
	bool includes(short x, short y, short map = 0) const;
	bool overlaps(cMapRectangle& other) const;
};

#endif

