/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __TARGETING_H__
#define __TARGETING_H__


#include "platform.h"	// Platform specifics
#include "typedefs.h"

class cPacket6C;

class cTargets
{
private:
	void CharTarget(P_CLIENT ps, cPacket6C *pt);
	void HouseSecureDown(UOXSOCKET s, P_CHAR Player, P_ITEM pi); // Ripper
	void HouseLockdown(UOXSOCKET s, P_CHAR Player, P_ITEM pi); // Abaddon
    void HouseRelease(UOXSOCKET s, P_CHAR Player, P_ITEM pi); // Abaddon
	void Priv3XTarget(int s, P_CHAR pc);
	void ShowPriv3Target(int s, P_CHAR pc); // Whose been screwing with this? cj 8/11/99
	void PlVBuy(int s, P_CHAR Player, P_ITEM pi);
	void RenameTarget(int s);
	void RemoveTarget(int s);
	void NewzTarget(int s);
	void TypeTarget(int s);
	void IstatsTarget(int s, cPacket6C *pt);
	void GhostTarget(P_CLIENT ps, P_CHAR pc);
	void AmountTarget(int s);
	void KickTarget(int s, P_CHAR pc);
	void VisibleTarget(int s, P_CHAR pc, P_ITEM pi);
	void DvatTarget(int s, P_CHAR Player, P_ITEM pi);
	void AllSetTarget(int s, P_CHAR pc);
	void TweakTarget(int s, P_CHAR pc, P_ITEM pi);
	void LoadCannon(int s, P_CHAR pc, P_ITEM pi);
	void SquelchTarg(int s, P_CHAR pc);
	void SwordTarget(P_CLIENT pC, cPacket6C *pt);
	void NpcTarget(int s, P_CHAR pc);
	void NpcTarget2(int s, P_CHAR pc);
	void NpcRectTarget(int s, P_CHAR pc);
	void NpcCircleTarget(int s, P_CHAR pc);
	void NpcWanderTarget(int s, P_CHAR pc);
	void NpcAITarget(int s, P_CHAR pc);
	void xBankTarget(int s, P_CHAR pc);
	void xSpecialBankTarget(int s, P_CHAR pc);//AntiChrist
	void DupeTarget(P_CLIENT pC, P_ITEM pi);
	void SellStuffTarget(int s, P_CHAR pc);
	void GmOpenTarget(int s, P_CHAR pc);
	void StaminaTarget(int s, P_CHAR pc);
	void ManaTarget(int s, P_CHAR pc);
	void MakeShopTarget(int s, P_CHAR pc);
	void AttackTarget(int s, P_CHAR pc);
	void FollowTarget(int s, P_CHAR pc);
	void TransferTarget(int s, P_CHAR pc);
	void BuyShopTarget(int s, P_CHAR pc);
	void permHideTarget(int s, P_CHAR pc, P_CHAR Player);
	void unHideTarget(int s, P_CHAR pc, P_CHAR Player);
	void SetSpeechTarget(int s, P_CHAR pc);
	void SetPoisonTarget(int s, P_CHAR pc);
	void SetPoisonedTarget(int s, P_CHAR pc);
	void FullStatsTarget(int s, P_CHAR pc);
	void SetAdvObjTarget(int s, P_CHAR pc);
	void CanTrainTarget(int s, P_CHAR pc);
	void SetSplitTarget(int s, P_CHAR pc);
	void SetSplitChanceTarget(int s, P_CHAR pc);
	void SetSpaDelayTarget(int s, P_CHAR pc);
	void NewXTarget(int s, P_CHAR pc, P_ITEM pi);
	void NewYTarget(int s, P_CHAR pc, P_ITEM pi);
	void IncXTarget(int s, P_CHAR pc, P_ITEM pi);
	void IncYTarget(int s, P_CHAR pc, P_ITEM pi);
	void BoltTarget(int s);
	void SetDirTarget(int s, P_CHAR pc, P_ITEM pi);
	void HouseOwnerTarget(int s, P_CHAR Player, P_CHAR pc);
	void HouseEjectTarget(int s, P_CHAR Player, P_CHAR pc);
	void HouseBanTarget(int s, P_CHAR Player,P_CHAR pc);
	void HouseFriendTarget(int s, P_CHAR Player,P_CHAR pc);
	void HouseUnlistTarget(int s,P_CHAR pc);
	void BanTarg(int s);
	void triggertarget(int s, P_ITEM pi); // By Magius(CHE)
	void GlowTarget(int s, P_CHAR Player, P_ITEM pi);
    void UnglowTarget(int s, P_CHAR Player, P_ITEM pi); 
	void ResurrectionTarget(UOXSOCKET s,P_CHAR pc);
	void MenuPrivTarg(int s);
	void ShowSkillTarget(int s,P_CHAR pc);
	//taken from 6904t2(5/10/99) - AntiChrist
	void GuardTarget(UOXSOCKET s, P_CHAR pc);
	void FetchTarget( UOXSOCKET s );
	void SetMurderCount(int s,P_CHAR pc);	// Abaddon 12 Sept 1999
	void ShowAccountCommentTarget(int s,P_CHAR pc);//AntiChrist
	void TargIdTarget(UOXSOCKET s, P_ITEM pi); // added -Fraz- 
	void FishTarget(P_CLIENT ps, short Tx, short Ty, short landid);
	void RevertSwapTarget(UOXSOCKET s,P_CHAR pc);
	void IDtarget(int s,P_CHAR pc, P_ITEM pi);
	void NpcMenuTarget(int s);
	bool NpcResurrectTarget(P_CHAR pc);
	void AddMenuTarget(int s, int addmitem);
	void Wiping(int s, cPacket6C *pt);

public:
	void MultiTarget(P_CLIENT ps);
	void JailTarget(int s, P_CHAR pc);
	void ReleaseTarget(int s, P_CHAR pc);
	void XTeleport(int s, P_CHAR Player, int x);
	int  BuyShop(int s,P_CHAR pc);
};
#endif
