/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

////////////////////////////////
// timers.h: interface for the timer classes.
//

#if !defined(__TIMERS_H__)
#define __TIMERS_H__


class cTimer
{
protected:
	unsigned int timer;		// The true value of the Stat
public:
	void  setValue(unsigned int val);
	void  setSecs(int val);
	void  setMilliSecs(int val);
	void  reset();
	unsigned int getValue() const;
	bool  IsRunning() const;
	bool  hasExpired() const;
	int	  getRemainingSecs() const;
};

class cSimpleTimer : public cTimer
{
public:
	bool  hasExpired();
//	NOTE: this is NOT virtual because our timers are not created by c'tors
};



#endif 
