/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

////////////////////////
// name:	basics.cpp
// purpose:	implementation of basic functions (that don't need LoneWolf definitions)
//
//

#include "basics.h"

int makenum2(char *s) // Converts string to integer
{
	unsigned int i;
	int n=0;
	unsigned int length=strlen(s);
	for(i=0;i<length;i++)
	{
		n*=10; // Multiply by 10
		if (isdigit(s[i])) n=n+(s[i])-48; // Convert char to number from 0 to 9
	}
	if (s[0]=='-') n=-n;
	return n;
}

int RandomNum(int nLowNum, int nHighNum)
{
	if (nHighNum - nLowNum + 1)
		return ((rand() % (nHighNum - nLowNum + 1)) + nLowNum);
	else
		return nLowNum;
}

