/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined(__COMMANDS_H__)
#define __COMMANDS_H__


#include "platform.h"	// Platform specifics
#include "typedefs.h"
#include "mstring.h"

class cRectangle;

void InitPages();
void donewithcall(int s, int type);

class cCommands
{

public:
	mstring command_line;

	vector<mstring> params;
	mstring GetAllParams(void);

	void NextCall(int s, int type);
	//void RepairWorld(int s);
	void KillSpawn(int s, int r);
	void RegSpawnMax(int s, int r);
	void RegSpawnNum(int s, int r, int n);
	void KillAll(int s, int percent, const char * sysmsg);
	void AddHere(int s, char z);
	void ShowGMQue(int s, int type);
	void Wipe(int s);
	void PartialWipe(int s, const cRectangle& rect, bool inverse);
	void WhoCommand(int s, int type, int buttonnum);
	void CPage(int s, char * reason);
	void GMPage(int s, char * reason);
	void MakePlace(int s, int i);
	void Command( UOXSOCKET, string );
	void MakeShop(P_CHAR pc);
	void DyeItem(int s);
	void SetItemTrigger(int s, P_ITEM pi);
	void SetTriggerType(int s, P_ITEM pi);
	void SetTriggerWord(int s, P_CHAR pc);
	void SetNPCTrigger(int s, P_CHAR pc);
	void DupeItem(P_CLIENT ps, P_ITEM pi, int amount);
	void Possess(int s);
	int cmd_offset;
	void GMtransfer(UOXSOCKET s);
	void GotoCur(UOXSOCKET s);
	bool GetPageReason(UOXSOCKET s, P_CHAR Player, char* comm);
};

#endif

