/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

// Newbie Stuff Code -- By McCleod

#include "newbie.h"
#include "skills.h"

#include "wolfpack.h"

#include "debug.h"
#undef  DBGFILE
#define DBGFILE "newbie.cpp"

static int nextbestskill(P_CHAR pc, int bstskll)  // Which skill is the second highest
{
	int i, a = 0, bestval = 0, skval = 0;

	int sk=SkillManager->getAllSkillsValue();
	for (i = 0; i < sk; i++) 
	{
		if (i==bstskll) continue;
		skval=pc->getRealSkill(i);
		if (skval > bestval && skval < pc->getRealSkill(bstskll))
		{
			a = i;
			bestval = skval;
		}
		if ( skval == pc->getRealSkill(bstskll))
		{
			a = i;
			bestval = skval;
		}
	}
	return a;
}


void newbieitems(UOXSOCKET sn, P_CHAR pc)
{
	if (!pc) return;
	int storeval, itemaddperskill, loopexit = 0;
	char whichsect[15];

	int first = bestskill(pc);
	int second = nextbestskill(pc, first);
	int third = nextbestskill(pc, second);
	if (pc->getRealSkill(third) < 190)
		third = 46;	// MEDITATION = NO items

	for (itemaddperskill = 1; itemaddperskill <= 4; itemaddperskill++)
	{
		switch (itemaddperskill)
		{
			case 1: sprintf(whichsect, "BESTSKILL %i", first);	break;
			case 2: sprintf(whichsect, "BESTSKILL %i", second);	break;
			case 3: sprintf(whichsect, "BESTSKILL %i", third);	break;
			case 4: strcpy(whichsect, "DEFAULT");				break;
			default:
				LogError("Fallout of switch.");
		}
		Script* Scp = findSection(newbie_script,whichsect);
		if (!Scp) return;
		while (Scp->NextLineSplitted() &&(++loopexit < MAXLOOPS))
		{
			if (!strcmp("PACKITEM", script1))
			{
				storeval = str2num(script2);
				scpMark m = Scp->Suspend();
				
				P_ITEM iN = Items->SpawnItemBackpack2(sn, storeval); // Tauriel 11-24-98
				if (iN!=NULL)
					iN->newbieOn(); // Mark as a newbie item
				strcpy(script1, "DUMMY");
				Scp->Resume(m);
			}
			/* pretty much nonsense imho. At the time of creation, NO newbie can already have a bankbox ! (Duke)
				else if (!strcmp("BANKITEM", script1))
				{
					storeval = str2num(script2);
					pos = ftell(scpfile);
					closescript();
				
					P_ITEM pi = Items->SpawnItemBank(pc, storeval); // Tauriel 11-24-98
					if (pi != NULL)
						pi->newbieOn(); // Mark as a newbie item
					strcpy(script1, "DUMMY");
					openscript("newbie.scp");
					fseek(scpfile, pos, SEEK_SET);
				} */
		}	
	    Scp->Close();
	}
}
 

  
