/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#if !defined(__STRUCTS_H__)
#define __STRUCTS_H__

// System Headers
#include <string>


// Wolfpack Headers
#include "platform.h"
#include "typedefs.h"
#include "defines.h"

using namespace std;

struct make_st
{
	int has;
	int has2;
	int needs;
	int minskill;
	int maxskill;
	short newColor; // This color is setted if coloring>-1
	int coloring;	// Color modification activated by trigger token!  // Magius(CHE) 
	short Mat1id;		// id of material 1 used to make item
	short Mat1color;	// color of material 1 used to make item
	short Mat2id;		// id of material 2 used to make item
	short Mat2color;	// color of material 2 used to make item
	int minrank; // value of minum rank level of the item to create! - Magius(CHE)
	int maxrank; // value of maximum rank level of the item to create! - Magius(CHE)
	int number; // Store Script Number used to Rank System by Magius(CHE)
};

struct antimacro_st
{
	// memorize server request
	unsigned long int QueryStartTime;
	std::string QueryString;

	// memorize client replies
	unsigned long int QueryAnswerTime;
	std::string QueryReplString;
};

#endif

