/////////////////////////////////////////
//
//	This software is LICENSED material !!
//	see LoneWolf.cpp for details.
//
//

#ifndef __TITLES_H__
#define __TITLES_H__

#include "typedefs.h"
#include "defines.h"
#include "skills.h"


//index for other array
enum othertags {KILLS_1_4=0,KILLS_5_9,KILLS_10_19,KILLS_20_49,KILLS_50_99,KILLS_100,ADMIN,
				SQUELCHED,OFFLINE,LADY,LORD,INVUL,GM,FROZEN,GUARDED,GUARDING,
				VENDOR,WAR,CRIMINAL,MURDERER,OTHERENTRIES};

//index for prowess array
enum prowesstags {SK10=0,SK20,SK30,SK40,SK50,SK60,SK70,SK80,SK90,SK100,SK110,SK120,PROWESSENTRIES};

//Index for fame array, KB = karma below, KO = Karma over
enum fametags {KB_10000,KB_5000,KB_2500,KB_1250,KB_625,KB625,KB1250,KB2500,KB5000,KB10000,KO10000,FAMEENTRIES};

class cTitle
{
	struct FameTitle
	{
		char *FO10000X;//fame over 10000 for lords
		char *FO10000Y;//fame over 10000 for ladies
		char *FB10000;//fame below 10000
		char *FB5000;//fame below 5000
		char *FB2500;//fame below 2500
		char *FB1250;//fame below 1250
	}; 
	FameTitle fame[FAMEENTRIES]; //Stores diferent fame titles
	bool is_reload; 
	char * skill[ALLSKILLSMAX+1]; // stores skill titles
	char * prowess[PROWESSENTRIES]; // stores prowess titles
	char * other[OTHERENTRIES]; // stores other titles
	char tempTitle[1024];
	void LoadTitles(char * Section,int MaxEntries,char *tokens[],char *title[]);
	char *GetProwessTitle(P_CHAR pc); //old title1()
	char *GetSkillTitle(P_CHAR pc);//old title2()
	char *GetFameTitle(P_CHAR pc); //old title3()
	void LoadFame();
	void freeMemory();
	char empty[2]; //used for void titles return
public:
	cTitle(); // old loadtitles();
	char *GetMurderTitle(P_CHAR pc);
	void ShowCname (int s, P_CHAR Player, P_CHAR pc, char seeSerial);
	char *GetTitle(P_CHAR Mount);
	void Reload();

};

#endif
